# TODO
# - package static libs
# 	/usr/lib/compel/fds.lib.a
#	/usr/lib/compel/scripts/compel-pack.lds.S
#	/usr/lib/compel/std.lib.a
#	/usr/lib64/libcompel.a
#	/usr/lib64/libcriu.a
#
# Conditional build:
%bcond_with	tests		# build and run tests (requires root)

Summary:	Checkpoint/restore functionality for Linux in userspace
Summary(pl.UTF-8):	Funkcja checkpoint/restore w przestrzeni użytkownika dla Linuksa
Name:		criu
Version:	3.16
Release:	2
License:	GPL v2 (tools), LGPL v2.1 (library)
Group:		Applications/System
Source0:	http://download.openvz.org/criu/%{name}-%{version}.tar.bz2
# Source0-md5:	f355b7eb8f4037d6b87b201815df7d7a
Patch0:		%{name}-python.patch
Patch1:		tests.patch
URL:		http://criu.org/
BuildRequires:	asciidoc
BuildRequires:	gnutls-devel
BuildRequires:	libbpf-devel
BuildRequires:	libbsd-devel
BuildRequires:	libcap-devel
BuildRequires:	libnet-devel
BuildRequires:	libnl-devel >= 1:3.2
BuildRequires:	libselinux-devel
BuildRequires:	nftables-devel
BuildRequires:	pkgconfig
BuildRequires:	protobuf
BuildRequires:	protobuf-c-devel
BuildRequires:	protobuf-devel
BuildRequires:	python3
BuildRequires:	python3-modules
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 2.007
BuildRequires:	sed >= 4.0
Requires:	%{name}-libs = %{version}-%{release}
Requires:	iproute2 >= 3.5
Requires:	uname(release) >= 3.11
ExclusiveArch:	%{x8664} %{armv7} %{armv8} aarch64 ppc64
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_libexecdir	%{_prefix}/lib

%description
Checkpoint/Restore In Userspace, or CRIU, is a software tool for Linux
operating system. Using this tool, you can freeze a running
application (or part of it) and checkpoint it to a hard drive as a
collection of files. You can then use the files to restore and run the
application from the point it was frozen at. The distinctive feature
of the CRIU project is that it is mainly implemented in user space.

%description -l en.UTF-8
Checkpoint/Restore In Userspace, or CRIU (pronounced kree-oo, IPA:
/krɪʊ/, Russian: криу), is a software tool for Linux operating system.
Using this tool, you can freeze a running application (or part of it)
and checkpoint it to a hard drive as a collection of files. You can
then use the files to restore and run the application from the point
it was frozen at. The distinctive feature of the CRIU project is that
it is mainly implemented in user space.

%description -l pl.UTF-8
CRIU (Checkpoint/Restore In Userspace) to narzędzie programowe dla
systemu operacyjnego Linux. Przy jego użyciu można zamrozić działającą
aplikację (lub jej część) i zapisać migawkę na twardym dysku jako
zestaw plików. Następnie można użyć tych plików do odtworzenia i
uruchomienia aplikacji od miejsca, w którym została zamrożona.
Wyróżnikiem projektu CRIU jest to, że został zaimplementowany głównie
w przestrzeni użytkownika.

%package libs
Summary:	CRIU shared library
Summary(pl.UTF-8):	Biblioteka współdzielona CRIU
License:	LGPL v2.1
Group:		Libraries

%description libs
CRIU shared library.

%description libs -l pl.UTF-8
Biblioteka współdzielona CRIU.

%package devel
Summary:	Header files for CRIU library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki CRIU
License:	LGPL v2.1
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}
Requires:	protobuf-c-devel

%description devel
Header files for CRIU library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki CRIU.

%package -n python3-pycriu
Summary:	Python interface to CRIU
Summary(pl.UTF-8):	Pythonowy interfejs do CRIU
Group:		Libraries/Python
Requires:	%{name}-libs = %{version}-%{release}
Obsoletes:	python-pycriu < 3.16

%description -n python3-pycriu
Python interface to CRIU. This package contains also crit utility.

%description -n python3-pycriu -l pl.UTF-8
Pythonowy interfejs do CRIU. Ten pakiet zawiera także narzędzie crit.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%{__sed} -i -e 's#-O2 -g#$(OPT)#g' Makefile

%{__sed} -i -e '1 s,#!.*env python.*,#!%{__python3},' scripts/criu-ns

%build
%define _make_opts \\\
	DEB_HOST_MULTIARCH= \\\
	CC="%{__cc}" \\\
	OPT="%{rpmcppflags} %{rpmcflags}" \\\
	PREFIX=%{_prefix} \\\
	LIBDIR=%{_libdir} \\\
	LOGROTATEDIR=%{_sysconfdir}/logrotate.d \\\
	LIBEXECDIR=%{_libexecdir} \\\
	PYSITESCRIPTDIR=%{py3_sitescriptdir} \\\
	MANDIR=%{_mandir} \\\
	WERROR=0 \\\
	SUBARCH=%{_target_cpu} \\\
	V=1
%{__make}

%if %{with tests}
%{__make} test
%endif

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install -p contrib/docker_cr.sh $RPM_BUILD_ROOT%{_libexecdir}/%{name}/scripts

# optional scripts, do not autogenerate bash dep
chmod -x $RPM_BUILD_ROOT%{_libexecdir}/%{name}/scripts/*.sh

%clean
rm -rf $RPM_BUILD_ROOT

%post   libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc CREDITS README.md
%attr(755,root,root) %{_bindir}/compel
%attr(755,root,root) %{_sbindir}/criu
%attr(755,root,root) %{_sbindir}/criu-ns
%{_mandir}/man1/compel.1*
%{_mandir}/man1/crit.1*
%{_mandir}/man1/criu-ns.1*
%{_mandir}/man8/criu.8*
%dir %{_libexecdir}/%{name}
%dir %{_libexecdir}/%{name}/scripts
%attr(755,root,root) %{_libexecdir}/%{name}/scripts/systemd-autofs-restart.sh
%attr(755,root,root) %{_libexecdir}/%{name}/scripts/docker_cr.sh

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libcompel.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libcompel.so.1
%attr(755,root,root) %{_libdir}/libcriu.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libcriu.so.2

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libcompel.so
%attr(755,root,root) %{_libdir}/libcriu.so
%{_includedir}/compel
%{_includedir}/criu
%{_pkgconfigdir}/criu.pc

%files -n python3-pycriu
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/crit
%{py3_sitescriptdir}/pycriu
%{py3_sitescriptdir}/crit-0.0.1-py*.egg-info
%changelog
* Fri Nov 05 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/criu.git;a=log;h=master

* Fri Nov 05 2021 Jan Palus <atler@pld-linux.org> 8826d8a
- Release 2 (by relup.sh)

* Sat Oct 09 2021 Jan Palus <atler@pld-linux.org> b7894ca
- R: protobuf-c-devel in -devel

* Mon Sep 27 2021 Jan Palus <atler@pld-linux.org> 9f1a25f
- up to 3.16

* Mon Jul 26 2021 Jan Palus <atler@pld-linux.org> 151b49e
- use new arm macros

* Tue Jun 15 2021 Jan Palus <atler@pld-linux.org> 9cf3d42
- paas target cpu explicitly instead of relying on `uname -m`

* Tue Jun 15 2021 Jan Palus <atler@pld-linux.org> cfee8eb
- rediff patches

* Wed May 26 2021 Jan Palus <atler@pld-linux.org> 08b7a2a
- reduce %{arm} applicability to armv7*

* Tue Nov 24 2020 Jan Palus <atler@pld-linux.org> 3c9ca18
- up to 3.15

* Tue Aug 11 2020 Jan Palus <atler@pld-linux.org> 63f4071
- up to 3.14

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> a934924
- add tests bcond (requires root)

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> 5929095
- package contrib/docker_cr.sh to libexec

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> a27aad5
- package systemd-autofs-restart.sh

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> 10de574
- package contrib

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> 6073a3d
- update arches, %{ix86} still fails in assembler

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> 7a48cad
- use _make_opts not to repeat make opts for build/install

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> db5fa3a
- up to 2.5, update runtime deps

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> 5c2bc50
- up to 2.4

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> 6e51e7f
- update BR

* Fri Jun 24 2016 Jakub Bogusz <qboosh@pld-linux.org> 83bc7f4
- updated to 2.3
- updated python patch
- system service dropped upstream (running as root is discouraged)

* Mon Nov 30 2015 Jacek Konieczny <j.konieczny@eggsoft.pl> 9a76cc9
- release 3 (by relup.sh)

